
k = SOSKernel.new;
v = k.view;

v.kernels // Array of Kernels
v.kernels.first === k

// true MVC
k.view;


//
k = SOSKernel.new
v = k.view;

// Plug these in an SOS.sr UGen
v.action_({ arg ...args; args.at(1).coefs.postln; });

//
s.boot;
(
SynthDef("SOS-filter", { arg out=0;
	var coefs, audioIn, audioEq;
	coefs = Control.names([\coefs]).kr([0,0,0,0,0]);
	//audioIn = In.ar(2,2);
	audioIn = LFSaw.ar(MouseX.kr(20,12e3,1),0,0.25).dup;
	audioEq = SOS.ar(audioIn, *coefs);
	Out.ar(out, audioEq);
}).add;
)

a = Synth('SOS-filter');

v.action_({ a.setn(\coefs, k.coefs); });

a.free

//


v = MagnitudeResponseView(Window("Magnitude Response", Rect(10,300,410,210)).alwaysOnTop_(true).front, Rect(10,10,390,190)).resize_(5).background_(Color.blue(0.1,0.1));

j = SOSKernel.new;
k = SOSKernel.new(1000);

v.kernels = j;
v.kernels = k;

v.kernels = [j, k];
v.kernels;

j.frequency = 400.0;
j.gain = 3.0;
j.q = 1.4;
j.paramsChanged;
v.refresh;

k.setFrequency( 2200.0 );
k.setQ( 1.4 );
k.setGain( 6.0 );
k.paramsChanged;

v.refresh;

v.maxdb
v.maxdb = 3.0;
v.maxdb = 6.0;
v.maxdb = 12.0;

v.lineWidth = 0.5;
v.lineWidth = 1.5;
v.lineWidth = 2.0;
v.lineWidth = 1.0;

k.frequency;
k.q;
k.gain;

k.gain = 0.0; k.paramsChanged; v.refresh;
k.gain = 3.0; k.paramsChanged; v.refresh;
k.gain = 6.0; k.paramsChanged; v.refresh;
k.q = 4.0; k.paramsChanged; v.refresh;
k.q = 1.0; k.paramsChanged; v.refresh;
k.q = 0.7; k.paramsChanged; v.refresh;

k.gain = 3.0; k.paramsChanged; v.refresh;
k.paramsChanged;

v.refresh;

k.filterKey
k.selectFilterType(\BHiShelf);
k.paramsChanged;
v.refresh;

v.selectedKernelIx;
v.selectedKernelIx=1;
v.selectedKernelIx=0;

j.filterClass
j.filterClass = BLowShelf;  k.paramsChanged; v.refresh;
j.frequency = 180.0
j.gain = 6.0;
j.q = 2.2;
j.paramsChanged;

v.refresh;

v.minFreq = 20.0;
v.maxFreq = 1e3;

v.maxdb = 9.0;
v.maxdb = 20.0;
v.maxdb = 12.0;

v.maxFreq = 12e3;
v.maxFreq = 20e3;

j.filterClass = BPeakEQ; k.paramsChanged; v.refresh;
k.filterClass = BPeakEQ; k.paramsChanged; v.refresh;
k.filterClass = BLowPass; k.paramsChanged; v.refresh;
k.filterClass = BHiPass; k.paramsChanged; v.refresh;
k.filterClass = BBandPass; k.paramsChanged; v.refresh;
k.filterClass = BBandStop; k.paramsChanged; v.refresh;
k.filterClass

k.selectFilterType('BLowPass');
k.selectFilterType('BHiPass');
k.selectFilterType('BPeakEQ');

[k.frequency, k.q, k.gain]

v.minFreq
v.maxFreq
v.minFreq = 20.0;
v.minFreq = 200.0;
v.maxFreq = 2000.0;
v.maxFreq = 12e3;
v.maxFreq = 20e3;
v.maxFreq = 22e3;

v.selectedKernelIx;

v.action_({ arg view; view.selectedKernelIx.postln; });
v.action_(nil);

//
k=SOSKernel.new;
v=k.view;

v.responseCurveLineWidth=1.5;
v.responseCurveLineColor=Color.black(0.1,0.1);
v.responseCurveLineColor=Color.blue;
v.responseCurveLineColor=Color.cyan;
v.responseCurveFillColor=Color.blue(0.5,0.2);
v.responseCurveLineColor=Color.grey;
v.responseCurveFillColor=Color.grey(0.4,0.4);
v.fillResponseCurve=true;
v.fillResponseCurve=false;
v.refresh;

v.cursorShape
v.cursorShape=\rect; v.refresh;
v.cursorShape=\fillRect; v.refresh;
v.cursorShape=\oval; v.refresh;
v.cursorShape=\fillOval; v.refresh;

v.refresh;

v.selectedCursorFillColor = Color.blue(0.1,0.1);
v.selectedCursorColor = Color.red;
v.selectedCursorColor = Color.blue;
v.selectedCursorColor = Color.white;
v.selectedCursorColor = Color(0.25,0.25,0.25,1);
v.nonSelectedCursorFillColor = Color.blue(0.1,0.1);
v.nonSelectedCursorColor = Color.blue(0.5,0.5);

v.refresh

v.cursorWidth
v.cursorHeight
v.cursorWidth=12
v.cursorHeight=12

MagnitudeResponseView

v.kernels = [SOSKernel(100.0), SOSKernel(1000.0)];

// ::
s.boot;

n = NodeProxy.new;
n.play;

n[0] = { In.ar(2,2); };

(
n[0] = { arg freq=1000.0, q=1.0, gain=0.0;
	var a0,a1,a2,b1,b2;
	#a0,a1,a2,b1,b2 = BPeakEQ.coefs(freq, q.reciprocal, gain);
	SOS.ar(In.ar(2,2), a0,a1,a2,b1,b2);
};
)

(
n[0] = { arg freq=1000.0, q=1.0, gain=0.0;
	var coefs;
	coefs = BPeakEQ.coefs(freq, q.reciprocal, gain);
	SOS.ar(In.ar(2,2), *coefs);
};
)

n.set(\freq, 1000.0, \q, 1.0, \gain, 6.0);
BPeakEQ.coefs(1000.0, 1.0.reciprocal, 6);

v.freq = 1000.0; v.q = 1.0; v.gain=6.0;
v.coefs;


n[0] = { arg in, a0, a1, a2, b1, b2; SOS.ar(In.ar(2,2), a0, a1, a2, b1, b2); };
n[2] = \filter -> { arg in, a0, a1, a2, b1, b2; SOS.ar(in, a0, a1, a2, b1, b2); };

n[0] = nil;
n[2] = nil;

v.coefs
n.set([['a0', 'a1', 'a2', 'b1', 'b2'], v.coefs].lace);

v.action;
v.action = nil;
(
v.action = { arg view;
	n.setNow([['a0', 'a1', 'a2', 'b1', 'b2'], v.coefs].lace);
};
)

s.dumpOSC(1);
s.dumpOSC(0);

s.queryAllNodes;

n.clear
n.free;


v.action_({ arg view; [view.frequency, view.q, view.gain].postln; });
v.action_({ arg view; n.set('freq', view.frequency, 'q', view.q, 'gain', view.gain); });
v.action_(nil);

v.frequency = 1000.0; v.q = 1.0; v.gain=6.0;
v.coefs;
v.filterClass.coefs(1000.0, 1.0.reciprocal, 6);


// ::
(
v = MagnitudeResponseView(
    Window("Magnitude Response", Rect(10,300,410,210))
    .alwaysOnTop_(true)
    .front,
    Rect(10,10,390,190)
).resize_(5).background_(Color.blue(0.5,0.1));

j = SOSKernel.new;
k = SOSKernel.new;
v.kernels = [j, k];
v.kernels;

j.frequency = 100.0;
j.gain = 3.0;
j.q = 0.7;

k.frequency = 1000.0;
k.q = 1.0;
k.gain = 6.0;

j.paramsChanged;
k.paramsChanged;
v.refresh;
)

v.editable;
v.editable = false;
v.editable = true;

k.filterClass = BHiShelf;
k.paramsChanged;
v.refresh;

j.filterClass = BHiPass;
j.q = 1.0;
j.paramsChanged;
v.refresh;

j.filterClass = BPeakEQ;
j.paramsChanged;
v.refresh;

j.frequency
j.q
j.gain

v.action = { arg view, ix, kernel; [ix, kernel.filterClass, kernel.freq, kernel.gain, kernel.q].postln; };

v.enabled = false;
v.enabled = true;

v.kernels.first
v.kernels.first.enabled;
v.kernels.first.enabled=false;
v.kernels.first.enabled=true;
v.refresh;

v.infoFont = Font("Arial", 14);
v.refresh;

v.infoFont = Font("Arial", 11);
v.refresh;


// ::

(
var window,cv,cv2,kpBounds,knobSize,specs,labels,initValues,kernel,filterKind;

knobSize=70@100;
kpBounds=KnobsPanel.viewSize(1,4,knobSize);

window=Window("EQ Bank", Rect(10,200,408,200+kpBounds.y)).front;
window.view.decorator=FlowLayout(window.view.bounds);

v = MagnitudeResponseView(window, Rect(10,10,400,190)).resize_(5).background_(Color.blue(0.1,0.1));

j = SOSKernel(100.0,0.7,3.0);
k = SOSKernel(1000.0,0.7,3.0);

v.kernels = [j, k];

kernel=v.selectedKernel;
labels=["Freq","Q","Gain","Amp"];
specs=[\freq,[0.01,20].asSpec,[-20,20].asSpec,\amp];
initValues=[kernel.freq,kernel.q,kernel.gain,0.25];

cv = CompositeView(window,Point(410,kpBounds.y+4));
cv.resize=7;
cv.decorator=FlowLayout(cv.bounds,0@0,2@2);
//cv.background = Color.blue(0.1,0.1);

// TODO: use SimpleController for these
p=KnobsPanel.new(cv,kpBounds,4,knobSize,labels,specs,initValues).front;
p.background = Color.blue(0.1,0.1);
p.at(0).action={|kn| kernel.setFreq(kn.value); v.refresh; };
p.at(1).action={|kn| kernel.setQ(kn.value); v.refresh; };
p.at(2).action={|kn| kernel.setGain(kn.value); v.refresh; };

v.action={|view,kernelIx,newKernel|
var newFreq, newQ, newGain;
	if (kernel!=newKernel) {
		kernel=newKernel;
		p.at(0).action={|kn| kernel.setFreq(kn.value); v.refresh; };
		p.at(1).action={|kn| kernel.setQ(kn.value); v.refresh; };
		p.at(2).action={|kn| kernel.setGain(kn.value); v.refresh; };
	};
	p.at(0).value=newKernel.freq;
	p.at(1).value=newKernel.q;
	p.at(2).value=newKernel.gain;
};

cv2 = CompositeView(cv,Point(97,kpBounds.y),0@0);
cv2.resize=7;
cv2.decorator=FlowLayout(cv2.bounds);
cv2.background = Color.blue(0.1,0.1);

filterKind = [ BPeakEQ, BLowShelf, BHiShelf, BLowPass, BHiPass, BBandPass, BBandStop ];
PopUpMenu(cv2,Point(90,20))
.items_(["BPeakEQ", "BLowShelf", "BHiShelf", "BLowPass", "BHiPass", "BBandPass", "BBandStop"])
.action_({ arg view;
	v.selectedKernel.setFilterClass( filterKind.at(view.value) );
	v.refresh;
});

PopUpMenu(cv2,Point(90,20))
.items_(["3.0", "6.0", "12.0", "20.0", "40.0", "80.0"])
.action_({ arg view;
	v.maxdb=[3,6,12,20,40,80].at(view.value);
	v.refresh;
})
.value_(2);

ToggleView(cv2,Point(90,18))
.font_(Font("Arial",11))
.string_("Enabled")
.value_(v.selectedKernel.enabled.binaryValue)
.action_({|btn|
	v.selectedKernel.enabled=btn.value==1;
	v.refresh;
});

TriggerView(cv2,Point(42,18))
.font_(Font("Arial",11))
.string_("Add")
.action_({|btn| if(btn.value==1){
	v.kernels=v.kernels.add(SOSKernel.new);
	v.refresh;
};
});

TriggerView(cv2,Point(42,18))
.font_(Font("Arial",11))
.string_("Del")
.action_({|btn| if(btn.value==1){
	v.kernels.removeAt(v.selectedKernelIx);
	v.refresh;
};
});

)
