KernelFilter {
	classvar
	<all;

	var
	<name,
	<className,
	<freqKey = 'freq',
	<gainKey = 'db',
	<qKey    = 'rq',
	<isQreciprocal = true;

	*initClass{
		StartUp.add {
			all = IdentityDictionary [
			];
		};
	}

	*new { arg name, className, freqKey='freq', gainKey='db', qKey='rq', isQreciprocal=true;
		^super.new.initKF(name, className, freqKey, gainKey, qKey, isQreciprocal);
	}
	initKF { arg inName, inClassName, inFreqKey, inGainKey, inQKey, inIsQreciprocal;
		name = inName; className = inClassName; freqKey = inFreqKey;
		gainKey = inGainKey; qKey = inQKey;
		isQreciprocal = inIsQreciprocal;
	}
	hasGain {
		^gainKey.notNil
	}
	hasQ {
		^qKey.notNil
	}
}
