// OnePole lpf
OnePoleLPF
OnePole.ar(in, exp(-2pi * cutoff * SampleDur.ir));

// FOS.ar(in, a0, a1, b1);
// Single pole low-pass filter
a0 = 1 - x
a1 = 0.0
b1 = x

// Single pole hi-pass filter
a0 =  (1+x)/2
a1 = -(1+x)/2
b1 = x

(
// 6db/oct Lowpass filter
{
var coef, freq;
    freq = MouseX.kr(20,12e3,1);
    coef = exp(-2pi * (freq * SampleDur.ir));
    FOS.ar(In.ar(2,2), 1 - coef, 0.0, coef);
}.play;
)

(
// 6db/oct hipass filter
{
var a0, a1, b1, x, freq;
    freq = MouseX.kr(20,12e3,1);
    x = exp(-2pi * (freq * SampleDur.ir));
    a0 = (1+x)/2;
    a1 = a0.neg;
    b1 = x;

    FOS.ar(In.ar(2,2),a0,a1,b1);
}.play;
)


// FOS magnitude response
cos_w0      = (2pi*freq*sampleDur).cos;
numerator   = (a0*a0)+(a1*a1)+(2*a0*a1*cos_w0);
denominator = 1+(b1*b1)-(2*b1*cos_w0);
magnitude   = (numerator/denominator).pow(1/2).dbamp;

// ::

{ OnePoleLPF.ar(In.ar(2,2), MouseX.kr(20,12e3,1)); }.play;
// names ok?
{ FOSlowpass.ar(In.ar(2,2), MouseX.kr(20,12e3,1)); }.play;

{ FOShipass.ar(In.ar(2,2), MouseX.kr(20,12e3,1)); }.play;

{ SVF.ar(In.ar(2,2), MouseX.kr(20,12e3,1), 0.0, 1.0); }.play;

{ BLowPass.ar(In.ar(2,2), MouseX.kr(20,12e3,1), 0.7); }.play;

{ BLowPass4.ar(In.ar(2,2), MouseX.kr(20,12e3,1), 0.7); }.play;

{ IIRFilter.ar(In.ar(2,2), MouseX.kr(20,12e3,1), 0.7); }.play;

{ In.ar(2,2); }.play;

s.scope;

s.freqscope;

k=FOSKernel.new;
v=k.view;
k.setFilterClass(FOShipass);
k.setFilterClass(FOSlowpass);

MagnitudeResponseView

// ::

(
// same as OnePole
{    var x;
    x = LFTri.ar(0.4, 0, 0.99);
    FOS.ar(LFSaw.ar(200, 0, 0.2), 1 - x.abs, 0.0, x)
}.play;
)

(
// same as OneZero
{    var x;
    x = LFTri.ar(0.4, 0, 0.99);
    FOS.ar(LFSaw.ar(200, 0, 0.2), 1 - x.abs, x, 0.0)
}.play;
)

(
// same as OnePole, kr
{    var x, ctl;
    x = LFTri.kr(0.2, 0, 0.99);
    ctl = FOS.kr(LFSaw.kr(8, 0, 0.2), 1 - x.abs, 0.0, x);
    LFTri.ar(ctl * 200 + 500);
}.play;
)
